SystemOrganization addCategory: #Roassal2GT!
SystemOrganization addCategory: 'Roassal2GT-Glamour'!
SystemOrganization addCategory: 'Roassal2GT-Glamour-Actions'!
SystemOrganization addCategory: 'Roassal2GT-Glamour-Context'!
SystemOrganization addCategory: 'Roassal2GT-Glamour-Roassal-Interaction'!
SystemOrganization addCategory: 'Roassal2GT-Inspector'!
SystemOrganization addCategory: 'Roassal2GT-Spotter'!

!RTShapeBuilderExample class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/7/2015 21:31'!
gtExamplesSource
	^ RTShapeBuilder! !

!RTGrapherExample class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:36'!
gtExamplesSource
	^ RTGrapher! !

!RTMenuBuilder class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/7/2015 21:24'!
gtExamplesProvider
	^ RTMenuBuilderExamples new! !

RTObject subclass: #GLMRoassal2Action
	instanceVariableNames: 'roassalPresentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

GLMRoassal2Action subclass: #GLMAbstractExportingAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMAbstractExportingAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 19:24'!
doExportToFull: fileName

	self subclassResponsibility! !

!GLMAbstractExportingAction methodsFor: 'hooks' stamp: 'JurajKubelka 11/3/2015 18:44'!
execute
	| fileName |
	fileName := UITheme builder 
						fileSave: 'Enter the ', self titleExtension,' file name'
						extensions: self extensions
						path: nil.
	fileName notNil ifTrue: [ 
		self doExportToFull: fileName asAbsolute ]! !

!GLMAbstractExportingAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 19:22'!
extensions
	"
	May return for example: #('png')
	"
	^ #()! !

!GLMAbstractExportingAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 19:21'!
title
	^ 'Export to ', self titleExtension! !

!GLMAbstractExportingAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 19:21'!
titleExtension
	^ 'TOOVERRIDE'! !

GLMAbstractExportingAction subclass: #GLMHTMLExporting2Action
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMHTMLExporting2Action methodsFor: 'hooks' stamp: 'AlexandreBergel 10/24/2015 19:52'!
doExportToFull: fileName
	RTHTML5Exporter new 
		directory: fileName parent;
		fileName: fileName basename; 
		export: self roassalView.
! !

!GLMHTMLExporting2Action methodsFor: 'hooks' stamp: 'AlexandreBergel 10/24/2015 19:51'!
extensions
	^ #('html')! !

!GLMHTMLExporting2Action methodsFor: 'hooks' stamp: 'AlexandreBergel 10/24/2015 19:55'!
titleExtension
	^ 'HTML...'! !

GLMAbstractExportingAction subclass: #GLMPNGExportingAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMPNGExportingAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 19:24'!
doExportToFull: fileName

	RTPNGExporter new 
				builder: self roassalView;
				fileName: fileName fullName;
				exportToFile.! !

!GLMPNGExportingAction methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 10/23/2015 19:22'!
extensions
	^ #('png')! !

!GLMPNGExportingAction methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 10/23/2015 19:21'!
titleExtension
	^ 'PNG'
	! !

GLMAbstractExportingAction subclass: #GLMSVGExportingAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMSVGExportingAction methodsFor: 'hooks' stamp: 'JurajKubelka 11/3/2015 19:21'!
doExportToFull: fileName

	RTSVGExporter 
		exportBuilderAsSVG: self roassalView
		filename: fileName asAbsolute! !

!GLMSVGExportingAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 19:25'!
extensions
	^ #('SVG')! !

!GLMSVGExportingAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 19:25'!
titleExtension
	^ 'SVG'
	! !

GLMRoassal2Action subclass: #GLMAbstractSetContextAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMAbstractSetContextAction methodsFor: 'accessing' stamp: 'AlexandreBergel 11/13/2015 18:08'!
contextClass
	"Override to return the class to be considered"
	self subclassResponsibility! !

!GLMAbstractSetContextAction methodsFor: 'hooks' stamp: 'AlexandreBergel 11/13/2015 19:20'!
execute
	"This method is executed by the menu offered by the Playground. Method #contextClass and #title have to be overriden"
	self inform: self roassalPresentation hash asString.
	self contextClass setOnView: self roassalView.
	self roassalUpdate! !

!GLMAbstractSetContextAction methodsFor: 'hooks' stamp: 'AlexandreBergel 11/13/2015 18:09'!
order
	^ 50! !

!GLMAbstractSetContextAction methodsFor: 'hooks' stamp: 'AlexandreBergel 11/13/2015 18:09'!
title
	^ 'Set context ', self contextClass name! !

GLMAbstractSetContextAction subclass: #GLMEmptyContextAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMEmptyContextAction methodsFor: 'accessing' stamp: 'AlexandreBergel 11/13/2015 18:09'!
contextClass
	^ RTEmptyViewContext! !

GLMAbstractSetContextAction subclass: #GLMInteractiveContextAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMInteractiveContextAction methodsFor: 'accessing' stamp: 'AlexandreBergel 11/13/2015 18:09'!
contextClass
	^ RTInteractiveViewContext! !

GLMRoassal2Action subclass: #GLMAddScrollbarAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMAddScrollbarAction methodsFor: 'hooks' stamp: 'AlexandreBergel 11/12/2015 17:43'!
execute
	self roassalView @ RTDoubleScrollBar.
	self roassalUpdate! !

!GLMAddScrollbarAction methodsFor: 'hooks' stamp: 'AlexandreBergel 11/12/2015 17:43'!
title
	^ 'Add scrollbars'! !

GLMRoassal2Action subclass: #GLMCameraCenterAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMCameraCenterAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 18:58'!
execute
	self trachelCanvas focusOnCenterScaled.
	self roassalUpdate! !

!GLMCameraCenterAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 18:59'!
icon
	^ GLMUIThemeExtraIcons glamorousZoomToFit! !

!GLMCameraCenterAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/27/2015 11:56'!
order
	^ 6! !

!GLMCameraCenterAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 18:59'!
title
	^ 'Camera center'! !

GLMRoassal2Action subclass: #GLMFindInViewAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMFindInViewAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/27/2015 21:11'!
execute
	GTSpotterMorph new
          extent: 400@500;
          spotterModel: (GTSpotter on: self roassalView);
          openCenteredInWorld! !

!GLMFindInViewAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/27/2015 21:09'!
icon
	^ GLMUIThemeExtraIcons glamorousInspect! !

!GLMFindInViewAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/27/2015 21:09'!
order
	^ 50! !

!GLMFindInViewAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/27/2015 21:10'!
title
	^ 'Find'! !

GLMRoassal2Action subclass: #GLMHTMLExportingAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMHTMLExportingAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/24/2015 19:44'!
execute
	| fileName |
	fileName := (RTHTML5Exporter new export: self roassalView) asUrl.
	self openIfPossible: fileName.! !

!GLMHTMLExportingAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/24/2015 19:47'!
openIfPossible: fileName
	"
	By Sean
	
	Gofer it
	smalltalkhubUser: 'SeanDeNigris' project: 'SeansPlayground';
	package: 'NewExternalWebBrowser';
	load.

	'http://google.com' asUrl open.
	"
	
	#NewExternalWebBrowser asClassIfPresent: [ :cls | fileName asUrl open ].
	#NewExternalWebBrowser asClassIfAbsent: [ 
		self inform: 'Try to load NewExternalWebBrowser to fast open of this file' ].! !

!GLMHTMLExportingAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/24/2015 19:45'!
title
	^ 'Export to HTML'! !

GLMRoassal2Action subclass: #GLMInspectViewAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMInspectViewAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/24/2015 19:53'!
execute
	self roassalView inspect! !

!GLMInspectViewAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/24/2015 19:53'!
title
	^ 'Inspect View'! !

!GLMRoassal2Action class methodsFor: 'initialization' stamp: 'AlexandreBergel 10/24/2015 19:40'!
allLeafSubclasses
	^ self allSubclasses select: #isLeaf! !

!GLMRoassal2Action class methodsFor: 'initialization' stamp: 'AlexandreBergel 10/24/2015 19:40'!
initializePresentation: aRoassal2Presentation
	| instances orderedInstances |
	instances := self allLeafSubclasses collect: #new.
	orderedInstances := instances sortedAs: #order.
	orderedInstances
		do:
			[ :inst | 
			inst roassalPresentation: aRoassal2Presentation.
			inst icon notNil
				ifTrue:
					[ aRoassal2Presentation
						act: [ :r | inst execute ]
						icon: inst icon
						entitled: inst title ]
				ifFalse:
					[ aRoassal2Presentation
						act: [ :r | inst execute ]
						entitled: inst title ] ]! !

!GLMRoassal2Action class methodsFor: 'testing' stamp: 'AlexandreBergel 10/24/2015 19:39'!
isLeaf
	^ self subclasses size = 0! !

!GLMRoassal2Action methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 18:53'!
execute
	"Override please"
	self subclassReponsibility! !

!GLMRoassal2Action methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 18:53'!
icon
	"Override please"
	^ nil! !

!GLMRoassal2Action methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 19:12'!
order
	^ 10! !

!GLMRoassal2Action methodsFor: 'accessing' stamp: 'AlexandreBergel 10/23/2015 18:52'!
roassalPresentation
	^ roassalPresentation! !

!GLMRoassal2Action methodsFor: 'accessing' stamp: 'AlexandreBergel 10/23/2015 18:52'!
roassalPresentation: anObject
	roassalPresentation := anObject! !

!GLMRoassal2Action methodsFor: 'do' stamp: 'AlexandreBergel 10/23/2015 19:08'!
roassalUpdate
	self roassalView signalUpdate ! !

!GLMRoassal2Action methodsFor: 'accessing' stamp: 'AlexandreBergel 10/23/2015 18:55'!
roassalView
	"Return the roassal view. Handy to be used in the actions"
	^ self roassalPresentation view view! !

!GLMRoassal2Action methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 18:53'!
title
	"Override please"
	^ 'Unamed'! !

!GLMRoassal2Action methodsFor: 'accessing' stamp: 'AlexandreBergel 10/23/2015 18:58'!
trachelCanvas
	^ self roassalView canvas! !

GLMRoassal2Action subclass: #GLMSelectableAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMSelectableAction methodsFor: 'hooks' stamp: 'AlexandreBergel 11/12/2015 22:04'!
execute
	| int |
	int := RTSelectableView new.
	self roassalView @ int.
	int when: RTSelectionEnd do: [ :evt | self inform: 'hello' ].! !

!GLMSelectableAction methodsFor: 'hooks' stamp: 'AlexandreBergel 11/12/2015 21:52'!
title
	^ 'Add selection'! !

GLMRoassal2Action subclass: #GLMZoomInAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMZoomInAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 19:11'!
execute
	RTZoomInMove on: self roassalView! !

!GLMZoomInAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 18:56'!
icon
	^ GLMUIThemeExtraIcons glamorousZoomIn! !

!GLMZoomInAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 19:12'!
order
	^ 1! !

!GLMZoomInAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 18:56'!
title
	^ 'Zoom in'! !

GLMRoassal2Action subclass: #GLMZoomOutAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMZoomOutAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 18:58'!
execute
	RTZoomOutMove on: self roassalView! !

!GLMZoomOutAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 19:10'!
icon
	^ GLMUIThemeExtraIcons glamorousZoomOut! !

!GLMZoomOutAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 19:12'!
order
	^ 5! !

!GLMZoomOutAction methodsFor: 'hooks' stamp: 'AlexandreBergel 10/23/2015 18:56'!
title
	^ 'Zoom in'! !

RTObject subclass: #RTAbstractViewContext
	instanceVariableNames: 'view presentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Context'!

!RTAbstractViewContext class methodsFor: 'private - utility' stamp: 'AlexandreBergel 11/12/2015 17:36'!
createContext
	"Define a new context in case none has been set"
	^ self defaultContextClass new! !

!RTAbstractViewContext class methodsFor: 'context' stamp: 'AlexandreBergel 11/12/2015 16:52'!
defaultContextClass
	"Return the default context used by Glamour when no context is set"
	^ self withAllSubclasses detect: #isDefault! !

!RTAbstractViewContext class methodsFor: 'private - utility' stamp: 'AlexandreBergel 11/12/2015 17:36'!
getContextFor: aView
	"Return the context associated to the view. It none is defined, then this method create one, and set it in view."
	^ aView attributeAt: #GlamourContext ifAbsentPut: [ self createContext ].
! !

!RTAbstractViewContext class methodsFor: 'testing' stamp: 'AlexandreBergel 11/12/2015 16:52'!
isDefault
	^ false! !

!RTAbstractViewContext class methodsFor: 'public' stamp: 'AlexandreBergel 11/16/2015 13:28'!
setOnView: aView
	"Set the context on the view"
	(aView hasAttribute: #GlamourContext) ifTrue: [ 
		(aView attributeAt: #GlamourContext) unregisterPreviousContext
	].
	aView attributeAt: #GlamourContext put: self new! !

!RTAbstractViewContext methodsFor: 'public' stamp: 'AlexandreBergel 11/13/2015 19:08'!
adjustView: aView inPresentation: aPresentation.
	self view: aView.
	self presentation: aPresentation.
	self registerCallbacks! !

!RTAbstractViewContext methodsFor: 'accessing' stamp: 'AlexandreBergel 11/12/2015 15:52'!
canvas
	^ view canvas! !

!RTAbstractViewContext methodsFor: 'hooks' stamp: 'AlexandreBergel 11/13/2015 18:42'!
interactionsToBeRegistered
	"Override to return a list of classes that have be to registered"
	self subclassResponsibility! !

!RTAbstractViewContext methodsFor: 'accessing' stamp: 'AlexandreBergel 11/12/2015 17:28'!
presentation
	"Return the Roassal2Presentation in which I am used"
	^ presentation! !

!RTAbstractViewContext methodsFor: 'accessing' stamp: 'AlexandreBergel 11/12/2015 16:40'!
presentation: aPresentation
	self assert: [ aPresentation isKindOf: GLMRoassal2Presentation ] description: 'Only a GLMRoassal2Presentation can be provided here'.
	presentation := aPresentation! !

!RTAbstractViewContext methodsFor: 'public' stamp: 'AlexandreBergel 11/13/2015 18:45'!
registerCallbacks
	"Register the different interactions on the view"
	self interactionsToBeRegistered 
		do: [ :intClass | self view @ (intClass new presentation: self presentation) ]! !

!RTAbstractViewContext methodsFor: 'public' stamp: 'AlexandreBergel 11/13/2015 18:54'!
removeFromView
	"Remove the context from the view. All the callbacks due to the interaction are removed as well"
	self view removeAttributeAt: #GlamourContext ifAbsent: [ ].

	self interactionsToBeRegistered do: [ :intClass | 
		self view removeInteractionIfPresent: intClass ]! !

!RTAbstractViewContext methodsFor: 'public' stamp: 'AlexandreBergel 11/13/2015 18:57'!
unregisterPreviousContext
	(self class getContextFor: self view) removeFromView! !

!RTAbstractViewContext methodsFor: 'accessing' stamp: 'AlexandreBergel 11/12/2015 15:52'!
view
	^ view! !

!RTAbstractViewContext methodsFor: 'accessing' stamp: 'AlexandreBergel 11/13/2015 18:55'!
view: aView
	"Set the view in the context"
	self assert: [ aView isKindOf: RTView ] description: 'Only a roassal view may be provided'.
	view := aView! !

RTAbstractViewContext subclass: #RTEmptyViewContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Context'!

!RTEmptyViewContext methodsFor: 'hooks' stamp: 'AlexandreBergel 11/13/2015 18:42'!
interactionsToBeRegistered
	^ #()! !

RTAbstractViewContext subclass: #RTInteractiveViewContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Context'!

!RTInteractiveViewContext class methodsFor: 'testing' stamp: 'AlexandreBergel 11/12/2015 16:52'!
isDefault
	^ true! !

!RTInteractiveViewContext methodsFor: 'hooks' stamp: 'AlexandreBergel 11/13/2015 18:43'!
interactionsToBeRegistered
	^ Array with: RTSelectableElementContextInteraction with: RTResizeableViewContextInteraction! !

!RTObject class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:52'!
gtExamplesFinder
	^ RTExampleFinder new
		source: self gtExamplesSource;
		provider: self gtExamplesProvider;
		subjects: self gtExamplesSubjects;
		yourself! !

!RTMenuBuilderExamples class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/7/2015 21:13'!
gtExamplesSource
	^ RTMenuBuilder! !

!RTGradientColoredLineExample class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:36'!
gtExamplesSource
	^ RTGradientColoredLine! !

GLMMorphicTest subclass: #GLMRoassal2MorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour'!

!GLMRoassal2MorphicTest commentStamp: '' prior: 0!
A GLMRoassalMorphicTest is xxxxxxxxx.
!

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'TudorGirba 2/13/2014 08:47'!
testCanvas
	| composer roassalMorph |
	composer := GLMCompositePresentation new.
	composer roassal2 painting: [:view :input | view add: RTElement new].
	window := composer openOn: 42.

	roassalMorph := self find: TRMorph in: window.
	self assert: (roassalMorph isKindOf: TRMorph)! !

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'AlexandreBergel 3/20/2015 15:08'!
testMondrianViewBuilder
	| composite |
	composite := GLMCompositePresentation new.
	composite roassal2 
					initializeView: [ RTMondrian new ];
					painting: [ :view | view nodes: (1 to: 42) ].
	window := composite openOn: 42.
	self assert: composite first view class = RTMondrian.
	self assert: composite first view view elements size = 42! !

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'AlexandreBergel 1/1/2015 20:08'!
testOpenTitled
	| v |
	v :=  RTBuilder new view.
	window := v openTitled: 'hello'! !

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'AlexandreBergel 1/1/2015 20:07'!
testOpenWithToolbarEntitled

	window := RTBuilder new openWithToolbarEntitled: 'hello'! !

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'AlexandreBergel 1/1/2015 20:09'!
testOpenWithToolbarEntitled02

	| v |
	v := RTView new.
	
	window := v openWithToolbarEntitled: 'hello'! !

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'TudorGirba 2/13/2014 08:47'!
testRoassalPresentationConstructor
	| composite |
	composite := GLMCompositePresentation new.
	composite roassal2.
	self assert: composite presentations size equals: 1.
	self assert: (composite presentations anyOne isKindOf: GLMRoassal2Presentation)! !

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'TudorGirba 2/13/2014 08:53'!
testUpdateUsesNewView
	| browser originalView newView |
	browser := GLMWrapper new.
	browser show: [ :a | 
		a roassal2 painting: [:view :roassal2 :input | view add: RTElement new ]].
	window := browser openOn: $d.

	originalView := (self find: TRMorph in: window) trachelCanvas.
	browser panes first presentations first update.
	newView := (self find: TRMorph in: window) trachelCanvas.
	
	self assert: newView ~~ originalView
! !

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'TudorGirba 10/26/2014 23:35'!
testUpdateViewIsProperlyLaidOut
	| browser originalView newView |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit
		to: #one;
		andShow: [ :a | a roassal2 painting: [ :view :input | 
			view addAll: (RTBox elementsOn: ($a to: input)).
			RTHorizontalLineLayout on: view elements ] ].
	window := browser openOn: $d.
	originalView := browser panes first presentations first view.
	self assert: (originalView elements detect: [ :each | each model = $b ]) center x equals: 17.5.
	browser panes first presentations first update.
	newView := browser panes first presentations first view.
	self assert: (newView elements detect: [ :each | each model = $b ]) center x equals: 17.5! !

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'TudorGirba 4/20/2015 07:30'!
testZoomingActionsWorkForMondrianBuilder
	| composite |
	composite := GLMCompositePresentation new.
	composite roassal2 initializeView: RTMondrian new.
	window := composite openOn: 42.
	self assert: composite first actions notEmpty.
	"these are the zooming actions"
	self shouldnt: (composite first actions first actOn: composite first) raise: Error.
	self shouldnt: (composite first actions second actOn: composite first) raise: Error.
	self shouldnt: (composite first actions third actOn: composite first) raise: Error
! !

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'TudorGirba 4/20/2015 07:30'!
testZoomingActionsWorkForView
	| composite |
	composite := GLMCompositePresentation new.
	composite roassal2.
	window := composite openOn: 42.
	self assert: composite first actions notEmpty.
	"these are the zooming actions"
	self shouldnt: (composite first actions first actOn: composite first) raise: Error.
	self shouldnt: (composite first actions second actOn: composite first) raise: Error.
	self shouldnt: (composite first actions third actOn: composite first) raise: Error
! !

!RTPieExample class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:34'!
gtExamplesSource
	^ RTPieBuilder! !

!RTSVGPath class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:11'!
gtExamplesProvider

	^ RTSVGExample new! !

!RTGrapher class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:13'!
gtExamplesProvider

	^ RTGrapherExample new! !

!RTLayoutExample class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:35'!
gtExamplesSource
	^ RTLayout! !

!RTExploraBuilder class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:13'!
gtExamplesProvider

	^ RTExploraBuilderExample new! !

!RTScrollBarBuilder class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/7/2015 21:25'!
gtExamplesProvider
	^ RTScrollBarBuilderExamples new! !

!RTMapBuilder class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:13'!
gtExamplesProvider

	^ RTMapExample new! !

!RTScrollBarBuilderExamples class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/7/2015 21:12'!
gtExamplesSource
	^ RTScrollBarBuilder! !

!RTComposerExample class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:37'!
gtExamplesSource
	^ RTComposer! !

!RTAxisAdaptedBuilder class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:14'!
gtExamplesProvider

	^ RTAxisAdaptedBuilderExample new! !

!RTSVGExporter class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/7/2015 21:25'!
gtExamplesProvider
	^ RTSVGExporterExample new! !

GLMPresentation subclass: #GLMRoassal2Presentation
	instanceVariableNames: 'painting paintingBlock view shouldPopulateSelection newViewBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour'!

!GLMRoassal2Presentation commentStamp: '' prior: 0!
A GLMRoassalPresentation is xxxxxxxxx.

Instance Variables
	newViewBlock:		<Object>
	painting:		<Object>
	paintingBlock:		<Object>
	shouldPopulateSelection:		<Object>
	view:		<Object>

newViewBlock
	- xxxxx

painting
	- xxxxx

paintingBlock
	- xxxxx

shouldPopulateSelection
	- xxxxx

view
	- xxxxx
!

!GLMRoassal2Presentation methodsFor: 'initialize-release' stamp: 'AlexandreBergel 10/24/2015 20:27'!
defaultActions
	GLMRoassal2Action initializePresentation: self! !

!GLMRoassal2Presentation methodsFor: 'context' stamp: 'AlexandreBergel 11/12/2015 17:37'!
getContextFor: aView
	"Return the context associated to the view. It none is defined, then this method create one, and set it in view."
	| context |
	context :=  RTAbstractViewContext getContextFor: aView.
	context view: aView.
	context presentation: self. 
	^ context! !

!GLMRoassal2Presentation methodsFor: 'initialize-release' stamp: 'TudorGirba 4/15/2014 07:39'!
initialize 
	super initialize.
	newViewBlock := [ RTView new ].
	shouldPopulateSelection := true.
	self defaultActions! !

!GLMRoassal2Presentation methodsFor: 'accessing' stamp: 'TudorGirba 2/13/2014 07:05'!
initializeView: aZeroArgBlock
	^ newViewBlock := aZeroArgBlock ! !

!GLMRoassal2Presentation methodsFor: 'accessing' stamp: 'TudorGirba 2/13/2014 07:05'!
newView
	view := nil.
	^ self view! !

!GLMRoassal2Presentation methodsFor: 'accessing' stamp: 'TudorGirba 2/13/2014 07:05'!
newViewBlock
	^ newViewBlock! !

!GLMRoassal2Presentation methodsFor: 'initialize-release' stamp: 'akevalion 7/14/2015 10:01'!
openIfPossible: fileName
	"
	By Sean
	
	Gofer it
	smalltalkhubUser: 'SeanDeNigris' project: 'SeansPlayground';
	package: 'NewExternalWebBrowser';
	load.

	'http://google.com' asUrl open.
	"
	
	#NewExternalWebBrowser asClassIfPresent: [ :cls | fileName asUrl open ].
	#NewExternalWebBrowser asClassIfAbsent: [ 
		self inform: 'Try to load NewExternalWebBrowser to fast open of this file' ].! !

!GLMRoassal2Presentation methodsFor: 'scripting' stamp: 'TudorGirba 2/13/2014 07:05'!
painting: anObject
	paintingBlock := anObject! !

!GLMRoassal2Presentation methodsFor: 'accessing' stamp: 'TudorGirba 2/13/2014 07:05'!
paintingBlock
	^ paintingBlock! !

!GLMRoassal2Presentation methodsFor: 'rendering' stamp: 'TudorGirba 2/13/2014 07:17'!
renderGlamorouslyOn: aRenderer
	self registerAnnouncements.
	^ aRenderer renderRoassal2Presentation: self! !

!GLMRoassal2Presentation methodsFor: 'rendering' stamp: 'AlexandreBergel 11/12/2015 17:39'!
renderOn: aViewOrBuilder
	self paintingBlock
		glamourValue:
			aViewOrBuilder asGlamorousMultiValue , self entity asGlamorousMultiValue
				, self asGlamorousMultiValue.
	aViewOrBuilder build.
	self useContextToInitialize: aViewOrBuilder view.
	self view: aViewOrBuilder! !

!GLMRoassal2Presentation methodsFor: 'accessing' stamp: 'TudorGirba 2/13/2014 08:41'!
shouldPopulateSelection
	^ shouldPopulateSelection! !

!GLMRoassal2Presentation methodsFor: 'accessing' stamp: 'AlexandreBergel 10/23/2015 18:47'!
shouldPopulateSelection: aBoolean
	"Configure whether elements present in the view should be clickable or not"
	shouldPopulateSelection := aBoolean! !

!GLMRoassal2Presentation methodsFor: 'context' stamp: 'AlexandreBergel 11/12/2015 17:37'!
useContextToInitialize: roassalView
	"Use the context of the view to initilize the view"
	| context |
	context := self getContextFor: roassalView.
	context adjustView: roassalView inPresentation: self! !

!GLMRoassal2Presentation methodsFor: 'accessing' stamp: 'TudorGirba 2/13/2014 07:05'!
view
	^ view ifNil: [ view := self newViewBlock value ]! !

!GLMRoassal2Presentation methodsFor: 'accessing' stamp: 'AlexandreBergel 10/23/2015 18:45'!
view: aRTView
	view := aRTView! !

!RTOSM class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/7/2015 21:25'!
gtExamplesProvider
	^ RTOpenStreeMapExample new! !

!RTSBFadeInteraction class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/7/2015 21:25'!
gtExamplesProvider
	^ RTSBFadeInteractionExamples new! !

GLMScriptingEditorTemplate subclass: #GLMRoassal2Easel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour'!

!GLMRoassal2Easel methodsFor: 'building' stamp: 'TudorGirba 10/4/2014 08:16'!
defaultScriptBindings
	^ {#view -> RTView new}! !

!GLMRoassal2Easel methodsFor: 'building' stamp: 'TudorGirba 10/4/2014 08:33'!
defaultScriptDisplayIn: aPresentation
	^ aPresentation 
		display: 'view';
		morphicAct: [:text | RTRoassalExample new open ] icon: GLMUIThemeExtraIcons glamorousExample entitled: 'Browse basic examples'! !

!GLMRoassal2Easel methodsFor: 'building' stamp: 'TudorGirba 10/4/2014 08:15'!
defaultTitle
	^ 'Roassal Easel'! !

!GLMRoassal2Easel methodsFor: 'private' stamp: 'TudorGirba 10/4/2014 08:29'!
evaluate: script in: context for: view
	| message |
	^ [ (Smalltalk compiler requestor: self) evaluate: script in: context to: context ]
		on: Error
		do: [ :e | 
			message := e class name , ': ' , e messageText.
			self inform: message.
			view add: (RTLabel new text: message; color: Color red; element) ]! !

!GLMRoassal2Easel methodsFor: 'building' stamp: 'TudorGirba 10/4/2014 08:17'!
resultIn: a
	^ a roassal2
		title: 'View';
		painting: [ :view :bindings :script | 
					| context |
					context := GLMDoItContext with: #view -> view withAll: bindings.
					self evaluate: script in: context for: view ]! !

!RTDepMatrix class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/7/2015 21:24'!
gtExamplesProvider
	^ RTDepMatrixExample new! !

!RTTextBuilderExamples class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/7/2015 21:09'!
gtExamplesSource
	^ RTTextBuilder! !

!RTBuilder class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 17:25'!
gtExampleBuilder
	<gtExample>
	<label: 'Example builder'>
	
	^ self new! !

!RTBuilder methodsFor: '*Roassal2GT-Inspector' stamp: 'TudorGirba 10/5/2014 12:16'!
gtInspectorViewIn: composite
	<gtInspectorPresentationOrder: -10>
	composite roassal2
		title: 'View';
		initializeView: [ self ]! !

!RTBuilder methodsFor: '*Roassal2GT-Glamour' stamp: 'TudorGirba 10/5/2014 12:16'!
openWithToolbar
	^ GLMCompositePresentation new 
		title: 'Roassal painting';
		with: [:composite |
			composite roassal2 initializeView: [ self ] ];
		openOn: self! !

!RTBuilder methodsFor: '*Roassal2GT-Glamour' stamp: 'TudorGirba 10/5/2014 12:16'!
openWithToolbarEntitled: aTitle
	^ self openWithToolbar title: aTitle! !

!RTStackBarPlotExample class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:34'!
gtExamplesSource
	^ RTStackBarPlot! !

!RTOpenStreeMapExample class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:34'!
gtExamplesSource
	^ RTOSM! !

!RTScrollPadBuilder class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/7/2015 21:26'!
gtExamplesProvider
	^ RTScrollPadBuilderExamples new! !

!RTScrollPadBuilderExamples class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/7/2015 21:12'!
gtExamplesSource
	^ RTScrollPadBuilder! !

!RTDepMatrixExample class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/7/2015 21:05'!
gtExamplesSource
	^ RTDepMatrix! !

!RTCompositeShape class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:13'!
gtExamplesProvider

	^ RTComposedShapeExample new! !

!RTStackBarPlot class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:13'!
gtExamplesProvider
	
	^ RTStackBarPlotExample new! !

!RTPieBuilder class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:13'!
gtExamplesProvider

	^ RTPieExample new! !

!RTTreeMapExample class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:33'!
gtExamplesSource
	^ RTTreeMapBuilder! !

!RTBoxPlotExample class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:38'!
gtExamplesSource
	^ RTBoxPlotDataSet! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicRoassal2Renderer
	instanceVariableNames: 'myMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour'!

!GLMMorphicRoassal2Renderer commentStamp: '' prior: 0!
A GLMMorphicRoassalRenderer is xxxxxxxxx.

Instance Variables
	myMorph:		<Object>

myMorph
	- xxxxx
!

!GLMMorphicRoassal2Renderer methodsFor: 'rendering' stamp: 'SergeStinckwich 6/19/2014 23:25'!
actOnPresentationUpdate: ann
	| aView canvas |
	aView := ann presentation newViewBlock value.
	ann presentation renderOn: aView.
	canvas := aView view setUpCanvas.
	myMorph 
		canvas: canvas;
		extent: canvas extent.
		! !

!GLMMorphicRoassal2Renderer methodsFor: 'rendering' stamp: 'AlexandreBergel 9/4/2015 18:38'!
render: aRoassalPresentation
	| view |
	view := aRoassalPresentation view.
	aRoassalPresentation renderOn: view.
	aRoassalPresentation when: GLMPresentationUpdated send: #actOnPresentationUpdate: to: self.
	^ myMorph := view view setUpCanvas buildMorph! !

!RTView class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 17:26'!
gtExampleEmptyView
	<gtExample>
	<label: 'Empty view'>
	
	^ self new! !

!RTView methodsFor: '*Roassal2GT-Inspector' stamp: 'TudorGirba 11/1/2014 23:12'!
gtInspectorElementsHierarchyIn: composite
	<gtInspectorPresentationOrder: 20>
	composite table 
		title: 'Elements';
		showOnly: 50;
		display: [ :each | each elements ];
		children: #nestedElements;
		column: 'Model' evaluated: [ :each | each model asString ];
		column: 'Shape' evaluated: [ :each | each shape asString ]! !

!RTView methodsFor: '*Roassal2GT-Inspector' stamp: 'AlexandreBergel 3/31/2014 14:24'!
gtInspectorViewIn: composite
	<gtInspectorPresentationOrder: -10>
	composite roassal2
		title: 'View';
		initializeView: [ self ]
		! !

!RTView methodsFor: '*Roassal2GT-Glamour' stamp: 'TudorGirba 10/7/2014 08:00'!
openWithToolbar
	^ GLMCompositePresentation new 
		title: 'Roassal painting';
		with: [:composite | composite roassal2 initializeView: [self ] ];
		openOn: self! !

!RTView methodsFor: '*Roassal2GT-Glamour' stamp: 'TudorGirba 10/7/2014 07:38'!
openWithToolbarEntitled: aTitle
	^ self openWithToolbar title: aTitle! !

!RTView methodsFor: '*Roassal2GT-Spotter' stamp: 'StefanReichhart 2/24/2015 14:46'!
spotterElementsFor: aStep
	<spotterOrder: 10>
	^ aStep listProcessor
		title: 'Elements';
		candidatesLimit: 100;
		allCandidates: [ self elements ];
		itemName: [ :each | each model gtDisplayString ];
		filter: GTFilterSubstring;
		wantsToDisplayOnEmptyQuery: true! !

!RTView methodsFor: '*Roassal2GT-Spotter' stamp: 'AndreiChis 7/12/2015 00:10'!
spotterPreviewIn: aComposite
	<spotterPreview: 10>
	
	self build.
	aComposite addBrickBack: self view setUpCanvas buildMorph

	! !

!RTElement methodsFor: '*Roassal2GT-Spotter' stamp: 'AlexandreBergel 1/9/2015 18:08'!
spotterActDefault
	self view canvas camera translateTo: self position.
	RTBlink on: self.! !

!RTSVGExample class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:44'!
gtExamplesSource
	^ RTSVGPath! !

!RTMondrianViewBuilder class methodsFor: '*Roassal2GT-Inspector' stamp: 'TudorGirba 11/30/2014 18:01'!
gtInspectorMondrianExamplesIn: composite
	<gtInspectorPresentationOrder: 0>
	^ RTMondrianExample new gtInspectorPreviewIn: composite! !

GTExample subclass: #RTExampleSelection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Inspector'!

!RTExampleSelection class methodsFor: 'examples' stamp: 'StefanReichhart 9/6/2015 17:25'!
gtExampleAtRandom
	<gtExample>
	<label: 'Random example'>
	
	^ RTAbstractExample subclasses atRandom new gtExamples atRandom! !

!RTExampleSelection class methodsFor: 'examples' stamp: 'StefanReichhart 9/8/2015 20:56'!
gtExampleFlags1
	<gtExample>
	<label: 'Example flags 1'>
	
	^ RTComposedShapeExample gtExamples
		detect: [ :example | example method selector = #exampleFlags ]
		ifNone: [ nil ]! !

!RTExampleSelection class methodsFor: 'examples' stamp: 'StefanReichhart 9/8/2015 23:40'!
gtExampleFlags2
	<gtExample>
	<label: 'Example flags 2'>
	
	^ (RTComposedShapeExample >> #exampleFlags) gtExamples first! !

!RTExampleSelection class methodsFor: 'examples' stamp: 'StefanReichhart 9/8/2015 23:40'!
gtExampleFlags3
	<gtExample>
	<label: 'Example flags 3'>
	
	^ (RTComposedShapeExample >> #exampleFlags) gtExample! !

!RTExampleSelection methodsFor: 'ui' stamp: 'AndreiChis 10/30/2015 14:04'!
gtDisplayPlaygroundIn: composite
	<gtInspectorPresentationOrder: 0>
	^ composite pharoScript
		title: 'Playground';
		format: [ 
			| sourceCode firstLine sourceCodeWithoutFirstLine |
			sourceCode := self method sourceCode.
			firstLine := sourceCode lines first.
			sourceCodeWithoutFirstLine := sourceCode copyFrom: firstLine size + 1 to: sourceCode size.
			sourceCodeWithoutFirstLine ];
		act: [ :text :page |
				text selectionInterval: (1 to: text text size).
				text evaluateSelectionAndDo: [ :anObject | text selection: anObject ] ]
			icon: GLMUIThemeExtraIcons glamorousGo
			on: $g
			entitled: 'Do it all and go (g)'
		! !

!RTExampleSelection methodsFor: 'ui' stamp: 'StefanReichhart 11/19/2015 20:51'!
gtInspectorRoassalViewIn: composite
	<gtInspectorPresentationOrder: -10>
	| returnValue |
	returnValue := self returnValue. " rt examples are no longer cached - we make a speed bump here "
	((Array with: RTView with: RTBuilder) noneSatisfy: [ :c | returnValue class includesBehavior: c ])
		ifTrue: [ ^ self ].
	composite roassal2
		title: 'Canvas';
		initializeView: [ returnValue ]
		! !

!RTExampleSelection methodsFor: 'ui' stamp: 'StefanReichhart 9/9/2015 20:13'!
gtInspectorViewIn: composite
	self deprecated: 'Please use #gtInspectorRoassalViewIn: instead'.
	^ self gtInspectorRoassalViewIn: composite! !

!RTExampleSelection methodsFor: '*Roassal2GT-Spotter' stamp: 'StefanReichhart 9/8/2015 21:12'!
gtSpotterPreviewIconIn: aComposite
	<spotterPreview: 10>
	(self provider class canPerform: (self selector, 'Icon') asSymbol)
		ifTrue: [ 
			aComposite addBrickBack: (self iconForm asAlphaImageMorph
				layout: #center;
				scale: 2.0) asBrick ]

	! !

!RTExampleSelection methodsFor: 'accessing' stamp: 'StefanReichhart 9/8/2015 20:49'!
icon
	form ifNil: [ self initializeIcon ].
	^ form! !

!RTExampleSelection methodsFor: 'public' stamp: 'StefanReichhart 9/9/2015 19:04'!
iconForm
	self deprecated: 'Please use #icon'.
	^ self icon! !

!RTExampleSelection methodsFor: 'testing' stamp: 'StefanReichhart 11/10/2015 19:50'!
ignoreCache
	^ true! !

!RTExampleSelection methodsFor: 'public' stamp: 'StefanReichhart 11/9/2015 20:38'!
initializeIcon
	| icon64Mime iconSelector |
	iconSelector := (self method selector, 'Icon') asSymbol.
	(self provider canPerform: iconSelector) ifFalse: [ ^ self ].
	icon64Mime := [ self provider perform: iconSelector ]
		on: Error
		do: [ ^ self ].
	form := [ TRPlatform current formClass fromBinaryStream: 
			(TRPlatform current mimeDecodeToBytes: icon64Mime readStream) ]
		on: Error
		do: [ ^ self ].! !

!RTExampleSelection methodsFor: '*Roassal2GT-Spotter' stamp: 'StefanReichhart 9/6/2015 18:36'!
matchesQuery: aSetOfNames
	| sourceCode |
	
	sourceCode := self method sourceCode asLowercase.
	^ aSetOfNames allSatisfy: [ :each | sourceCode includesSubstring: each ]
! !

!RTExampleSelection methodsFor: '*Roassal2GT-Spotter' stamp: 'StefanReichhart 9/9/2015 20:14'!
spotterPreviewExampleIn: aComposite
	self deprecated: 'Please use #gtSpotterPreviewIconIn: instead'>
	self gtSpotterPreviewIconIn: aComposite
	! !

!RTAnimatedScatterPlot class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:14'!
gtExamplesProvider

	^ RTAnimatedScatterPlotExample new! !

!RTSpectrograph class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:12'!
gtExamplesProvider
	
	^ RTSpectrographExample new! !

GLMExamples subclass: #GLMRoassal2Examples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour'!

!GLMRoassal2Examples methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 3/20/2015 15:08'!
roassalPainting
	<glmBrowser: 'Roassal painting' input: '42'>
	"self new roassalPainting openOn: 42"
	| browser |
	browser := GLMTabulator withStatusbar.
	browser column: #one; column: #two.
	browser transmit to: #one; andShow: [ :a |
		a list 
			title: 'Select and trigger from menu';
			display: [:x | 1 to: x ];
			selectionAct: [:list | 
				| value |
				value := list selection * 10. "simulate some custom setup"
				(list pane port: #customSelection) value: value ] 
			entitled:  'Multiply by 10 and then send outside'
			].
	browser transmit to: #two; from: #one port: #customSelection; andShow: [ :a |
		a roassal2
			title: 'Numbers in Roassal';
			initializeView: [ RTMondrian new ];
			painting: [:view :number | 
				view shape label.
				view nodes: (1 to: number).
				view edges connectFrom: [:each | each // 5 ].
				view layout tree ] ].
	^ browser! !

!TRCanvas class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 17:27'!
gtExampleEmpty
	<gtExample>
	<label: 'Empty canvas'>
	
	^ TRCanvas new! !

!TRCanvas methodsFor: '*Roassal2GT-Inspector' stamp: 'AlexandreBergel 9/8/2014 11:41'!
gtInspectorViewIn: composite
	<gtInspectorPresentationOrder: -10>
	composite roassal2
		title: 'Canvas';
		initializeView: [ RTView new setCanvas: self ]
		! !

!RTMondrianExample class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:13'!
gtExamplesProvider

	^ RTMondrianExample new! !

!RTMondrianExample class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:45'!
gtExamplesSource
	^ RTMondrianExample! !

!RTKiviatBuilderExample class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:36'!
gtExamplesSource
	^ RTKiviatBuilder! !

!RTSVGExporterExample class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/7/2015 20:47'!
gtExamplesSource
	^ RTSVGExporter! !

!RTShapeBuilder class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/7/2015 21:27'!
gtExamplesProvider
	^ RTShapeBuilderExample new! !

!RTTextBuilder class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/7/2015 21:26'!
gtExamplesProvider
	^ RTTextBuilderExamples new! !

!RTLayout class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:13'!
gtExamplesProvider

	^ RTLayoutExample new! !

!RTKiviatBuilder class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:13'!
gtExamplesProvider

	^ RTKiviatBuilderExample new! !

!RTAnimatedScatterPlotExample class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:38'!
gtExamplesSource
	^ RTAnimatedScatterPlot! !

RTTest subclass: #RTGTContext
	instanceVariableNames: 'prez view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Context'!

!RTGTContext methodsFor: 'tests' stamp: 'AlexandreBergel 11/13/2015 18:48'!
setUp
	super setUp.
	prez := GLMRoassal2Presentation new.
	view := RTView new.! !

!RTGTContext methodsFor: 'tests' stamp: 'AlexandreBergel 11/13/2015 18:48'!
testGetContextFor

	| context |
	self deny: view hasAttributes.
	context := prez getContextFor: view.
	self assert: context notNil.
	self assert: context class equals: RTAbstractViewContext defaultContextClass.
	self assert: (context class inheritsFrom: RTAbstractViewContext).
	self assert: view hasAttributes.! !

!RTGTContext methodsFor: 'tests' stamp: 'AlexandreBergel 11/13/2015 18:49'!
testGetContextFor02

	| context |
	context := prez getContextFor: view.

	self assert: (RTAbstractViewContext getContextFor: view) equals: context.
	
	RTEmptyViewContext setOnView: view.	
	self assert: (RTAbstractViewContext getContextFor: view) ~~ context.
	self assert: (RTAbstractViewContext getContextFor: view) class equals: RTEmptyViewContext.! !

!RTGTContext methodsFor: 'removing context' stamp: 'AlexandreBergel 11/13/2015 18:54'!
testRemovingContext
	| c |
	self assert: view announcer numberOfSubscriptions equals: 0.
	RTInteractiveViewContext setOnView: view.
	self assert: view announcer numberOfSubscriptions equals: 0.
	prez useContextToInitialize: view.
	self assert: view announcer numberOfSubscriptions equals: 1.
	
	c := prez getContextFor: view.
	self assert: c class equals: RTInteractiveViewContext.
	c removeFromView.
	self assert: view announcer numberOfSubscriptions equals: 0.! !

!RTGTContext methodsFor: 'removing context' stamp: 'AlexandreBergel 11/13/2015 19:07'!
testRemovingContext02
	RTInteractiveViewContext setOnView: view.
	prez useContextToInitialize: view.
	self assert: view announcer numberOfSubscriptions equals: 1.
	"self assert: (view hasInteraction: RTSelectableElementContextInteraction)."
	self assert: (view hasInteraction: RTResizeableViewContextInteraction).

	RTEmptyViewContext setOnView: view.
	prez useContextToInitialize: view.
	self assert: view announcer numberOfSubscriptions equals: 0.

	RTInteractiveViewContext setOnView: view.
	prez useContextToInitialize: view.
	self assert: view announcer numberOfSubscriptions equals: 1.
! !

!RTGTContext methodsFor: 'tests' stamp: 'AlexandreBergel 11/12/2015 16:53'!
testdefaultContextClass
	self assert: RTAbstractViewContext defaultContextClass notNil.
	self assert: RTAbstractViewContext defaultContextClass isBehavior.! !

!RTGTContext methodsFor: 'tests' stamp: 'AlexandreBergel 11/13/2015 18:49'!
testuseContextToInitialize

	self assert: view announcer numberOfSubscriptions = 0.
	prez useContextToInitialize: view.
	self assert: view announcer numberOfSubscriptions > 0! !

RTTest subclass: #RTGTContextInteractionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Roassal-Interaction'!

!RTGTContextInteractionTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/16/2015 13:31'!
testBasic

	| v int |
	v := RTView new.
	int := RTEmptyViewContextInteraction new.
	v @ int.
	self assert: (RTAbstractViewContext getContextFor: v) class equals: RTEmptyViewContext.! !

!RTGTContextInteractionTest methodsFor: 'tests' stamp: 'AlexandreBergel 11/16/2015 13:32'!
testBasic02

	| v int |
	v := RTView new.
	int := RTResizeableViewContextInteraction new.
	v @ int.
	self assert: (RTAbstractViewContext getContextFor: v) class equals: RTInteractiveViewContext.! !

!RTSunburstBuilder class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:13'!
gtExamplesProvider
	
	^ RTSunburstBuilderExamples new! !

!GLMCompositePresentation methodsFor: '*Roassal2GT-Glamour' stamp: 'TudorGirba 2/13/2014 07:06'!
roassal2
	^ self custom: GLMRoassal2Presentation new! !

!RTBoxPlotDataSet class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:14'!
gtExamplesProvider

	^ RTBoxPlotExample new! !

!GLMMorphicRenderer methodsFor: '*Roassal2GT-Glamour' stamp: 'TudorGirba 2/13/2014 07:13'!
renderRoassal2Presentation: aPresentation
	^ GLMMorphicRoassal2Renderer render: aPresentation from: self! !

!RTSpectrographExample class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:32'!
gtExamplesSource
	^ RTSpectrograph! !

!RTMapExample class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:35'!
gtExamplesSource
	^ RTMapBuilder! !

!RTSunburstBuilderExamples class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:33'!
gtExamplesSource
	^ RTSunburstBuilder! !

!RTGradientColoredLine class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:13'!
gtExamplesProvider

	^ RTGradientColoredLineExample new! !

!RTSBFadeInteractionExamples class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/7/2015 21:17'!
gtExamplesSource
	^ RTSBFadeInteraction! !

!RTAbstractExample class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 19:11'!
gtExamplesProvider
	^ self new! !

!RTAbstractExample class methodsFor: '*Roassal2GT-Inspector' stamp: 'AndreiChis 1/14/2015 15:39'!
gtInspectorPreviewIn: composite
	<gtInspectorPresentationOrder: 4>
	<gtInspectorTag: #examples>
	^ self new gtInspectorPreviewIn: composite! !

!RTAbstractExample methodsFor: '*Roassal2GT-Inspector' stamp: 'AndreiChis 10/30/2014 14:40'!
gtDisplayExamplesIn: aComposite

	^ (self gtInspectorPreviewIn: aComposite)
		title: 'E.g'! !

!RTAbstractExample methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/9/2015 09:10'!
gtInspectorPreviewIn: composite
	<gtInspectorPresentationOrder: 4>
	^ composite roassal2
		title: 'Examples';
		when: [ self gtExamples notEmpty ];
		send: [ :example | example ];
		painting: [ :view | 
			view @ RTDraggableView.
			self gtOpenOn: view ]! !

!RTAbstractExample methodsFor: '*Roassal2GT-Inspector' stamp: 'AlexandreBergel 10/27/2015 14:54'!
gtOpenOn: v
	|  icon64Mime form element  |

	self gtExamples do: [ :anExample |
		icon64Mime := self perform: (anExample method selector, #Icon) asSymbol.
		form := TRPlatform current formClass fromBinaryStream: 
							(TRPlatform current mimeDecodeToBytes: icon64Mime readStream).
		element := (RTBitmap new form: form) elementOn: anExample.
		element @ (RTPopup new text: anExample method selector asString).
		element @ (RTEventForwarder new eventClass: TRMouseDragging). 
		element when: TRMouseClick do: [ :event |
			self announcer announce: (RTExampleOpeningEvent new theClass: self className; theSelector: anExample method selector).
		].
		v add: element ].

	RTGridLayout new on: v elements.
	! !

!RTComposer class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:13'!
gtExamplesProvider

	^ RTComposerExample new! !

!RTTreeMapBuilder class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:13'!
gtExamplesProvider
	
	^ RTTreeMapExample new! !

GTExampleFinder subclass: #RTExampleFinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Inspector'!

!RTExampleFinder class methodsFor: 'examples' stamp: 'StefanReichhart 9/9/2015 23:25'!
gtExampleInstance
	<gtExample>
	<label: 'An example finder on the source #RTExploraBuilder and provider #RTExploraBuilderExample'>
	
	^ self new
		source: RTExploraBuilder;
		provider: RTExploraBuilderExample new;
		subjects: #();
		yourself! !

!RTExampleFinder methodsFor: 'private' stamp: 'StefanReichhart 9/9/2015 19:05'!
class: aClass selector: aSelector method: aMethod to: examples
	(aSelector beginsWith: 'example') ifFalse: [ ^ self ].
	(aSelector endsWith: 'Icon') ifTrue: [ ^ self ].
	
	self example: (self class: aClass selector: aSelector method: aMethod pragma: (self newImpostorPragma: aMethod)) to: examples! !

!RTExampleFinder methodsFor: 'private' stamp: 'StefanReichhart 9/6/2015 19:50'!
newExample
	^ RTExampleSelection new! !

!RTComposedShapeExample class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:37'!
gtExamplesSource
	^ RTCompositeShape! !

TestCase subclass: #GLMCameraCenterActionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMCameraCenterActionTest methodsFor: 'tests' stamp: 'AlexandreBergel 10/23/2015 19:07'!
testBasic

	| inst |
	inst := GLMCameraCenterAction new.
	inst roassalPresentation: GLMRoassal2Presentation new.
	inst execute! !

TestCase subclass: #GLMRoassal2ActionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Actions'!

!GLMRoassal2ActionTest methodsFor: 'tests' stamp: 'AlexandreBergel 10/27/2015 11:54'!
testInitialize
	| prez nbActionOriginal |
	prez := GLMRoassal2Presentation new.
	nbActionOriginal := prez actions size.
	GLMRoassal2Action initializePresentation: prez.
	self assert: prez actions size - nbActionOriginal equals: GLMRoassal2Action allLeafSubclasses size.! !

!RTAxisAdaptedBuilderExample class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:38'!
gtExamplesSource
	^ RTAxisAdaptedBuilder! !

!RTExploraBuilderExample class methodsFor: '*Roassal2GT-Inspector' stamp: 'StefanReichhart 9/6/2015 20:37'!
gtExamplesSource
	^ RTExploraBuilder! !

RTInteraction subclass: #RTAbstractContextInteraction
	instanceVariableNames: 'presentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Roassal-Interaction'!

!RTAbstractContextInteraction methodsFor: 'accessing' stamp: 'AlexandreBergel 11/13/2015 18:34'!
presentation
	^ presentation! !

!RTAbstractContextInteraction methodsFor: 'accessing' stamp: 'AlexandreBergel 11/13/2015 18:35'!
presentation: aGLRoassalPresentation
	presentation := aGLRoassalPresentation! !

RTAbstractContextInteraction subclass: #RTEmptyViewContextInteraction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Roassal-Interaction'!

!RTEmptyViewContextInteraction commentStamp: 'AlexandreBergel 11/16/2015 13:35' prior: 0!
Interaction for a view. Make the view __not__ resizeable in GTInspector. Here is an example:
-=-=-=
b := RTMondrian new.
b nodes: (1 to: 100).
b layout grid.
b view @ RTEmptyViewContextInteraction.
b
-=-=-=!

!RTEmptyViewContextInteraction methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 11/16/2015 13:28'!
initializeElement: aView
	RTEmptyViewContext setOnView: aView ! !

RTAbstractContextInteraction subclass: #RTResizeableViewContextInteraction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Roassal-Interaction'!

!RTResizeableViewContextInteraction commentStamp: 'AlexandreBergel 11/16/2015 13:35' prior: 0!
Interaction for a view. Make the view resizeable in GTInspector. Here is an example:
-=-=-=
b := RTMondrian new.
b nodes: (1 to: 100).
b layout grid.
b view @ RTResizeableViewContextInteraction.
b
-=-=-=!

!RTResizeableViewContextInteraction methodsFor: 'hooks' stamp: 'AlexandreBergel 11/16/2015 13:32'!
initializeElement: aView
	"self assert: [ self presentation notNil ] description: 'The presentation has to be set'."

	aView canvas
		when: TRResizeCanvasEvent
		do: [ :evt | 
			| es |
			es := aView elements asGroup encompassingRectangle. 
			(es width + es height) > 4000
				ifFalse: [ aView canvas focusOnCenterScaled ] ]! !

RTAbstractContextInteraction subclass: #RTSelectableElementContextInteraction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Glamour-Roassal-Interaction'!

!RTSelectableElementContextInteraction methodsFor: 'hooks' stamp: 'AlexandreBergel 11/13/2015 18:35'!
initializeElement: aView
	self assert: [ self presentation notNil ] description: 'The presentation has to be set'.
	
	aView elements do: [:each |  
		each when: TRMouseLeftClick do: [ :event | 
			each model ifNotNil: [ self presentation selection: each model ] ] ].! !

RTInteraction subclass: #RTFindInAView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal2GT-Spotter'!

!RTFindInAView methodsFor: 'hooks' stamp: 'AliakseiSyrel 1/19/2015 21:36'!
initializeElement: aView

	| mb |
	mb := RTMenuBuilder new.
	mb view: aView.
	mb menu: 'Find' callback: [ 
        GTSpotterMorph new
                        extent: 400@500;
                        spotterModel: (GTSpotter on: aView);
                        openCenteredInWorld ].
	mb build! !
